.386
.model flat,stdcall
option casemap:none

include          windows.inc
include          gdi32.inc
includelib       gdi32.lib
include          user32.inc
includelib       user32.lib
include          kernel32.inc
includelib       kernel32.lib
include macro.asm

IDD_MAIN				equ	101
;--------------------------------the code below is almost yours

include ws2_32.inc
includelib ws2_32.lib

WM_FSOCKET equ WM_USER + 0fh



.data
	wsadata WSADATA <>
	sin sockaddr_in <> 
.data?
	sock dd ?
	error_code dd ?
	hInstance	dd ?
.code

fInitInternet proc hWnd:dword
	;	Mad wizard tutorial
	
	invoke WSAStartup,101h,addr wsadata
	.if eax!=0
		xor eax,eax
		dec eax
		ret
	.endif
	
	invoke socket,AF_INET,SOCK_STREAM,0     ; Create a stream socket for internet use 
	.if eax!=INVALID_SOCKET 
	    mov sock,eax 
		invoke WSAAsyncSelect,sock,hWnd,WM_FSOCKET,FD_CONNECT+FD_READ+FD_CLOSE+FD_WRITE+FD_ACCEPT
	.else
		invoke MessageBox,hWnd,CTXT("Internet connection initialization error"),CTXT("Unknown cause"),MB_OK
	.endif
		
	
	ret
fInitInternet endp

fCloseInternet proc
	
	invoke closesocket,sock
	invoke WSACleanup
	
	ret
fCloseInternet endp

fConnect proc uses esi edi lpszHostName:dword,nPortNumber:dword
	
	mov sin.sin_family, AF_INET 
	invoke htons, nPortNumber
	mov sin.sin_port,ax
	invoke gethostbyname, lpszHostName
	.if eax==0
		;invoke PERR
		ret
	.endif
	mov eax,[eax+12]
	
	mov eax,[eax]                      ; copy the pointer to the actual IP address into eax 
	mov eax,[eax]                      ; copy IP address into eax 
	mov sin.sin_addr,eax 
	
	invoke connect,sock,addr sin,sizeof sin 
	.if eax==SOCKET_ERROR
		invoke WSAGetLastError          
	.endif 
	
	
	ret
fConnect endp
;---------------------------------------------------------the code upon is almost yours
DlgProc proc uses esi edi ebx hDlg,uMsg,wParam,lParam
	.if uMsg==WM_INITDIALOG
		invoke fInitInternet,hDlg ;call your function
		invoke fConnect,CTXT("127.0.0.1"),8888 ;call your function
	.elseif uMsg==WM_FSOCKET
		mov eax,lParam
		.if ax==FD_CONNECT
			shr eax,16
			.if ax==0 ;connect success
				invoke send,wParam,CTXT("this is the message sent by client.exe"),39,0
			.else ;connect error and ax is the error code
				invoke MessageBox,hDlg,CTXT("connect error....."),0,MB_ICONERROR
			.endif
		.endif
	.elseif uMsg==WM_CLOSE
		invoke EndDialog,hDlg,FALSE
	.else
		mov eax,FALSE
		ret
	.endif
	mov eax,TRUE
ret
DlgProc endp

start:
	invoke GetModuleHandle,0
	mov hInstance,eax
	invoke DialogBoxParam,hInstance,IDD_MAIN,0,offset DlgProc,0
	invoke ExitProcess,0
end start